"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_1 = require("graphql");
var types_1 = require("./types");
var IDFIELD = {
    id: {
        description: 'here id of a location',
        type: new graphql_1.GraphQLNonNull(graphql_1.GraphQLString)
    }
};
var COUNTRY = {
    country: {
        description: 'The country the data should be pulled from.',
        type: new graphql_1.GraphQLNonNull(graphql_1.GraphQLString)
    }
};
var LANGUAGE = {
    language: {
        description: 'The preferred language of the data.',
        type: new graphql_1.GraphQLNonNull(graphql_1.GraphQLString)
    }
};
function wrapOptionals(o) {
    return __assign({}, o, LANGUAGE, COUNTRY, { optionals: {
            description: 'be faster',
            type: new graphql_1.GraphQLList(graphql_1.GraphQLString)
        } });
}
function toOutput(f) {
    return f;
}
function testOutputType(direction, objectTypeFactory) {
    return types_1.typeWrapper(new graphql_1.GraphQLList(objectTypeFactory({
        name: "TestOutput" + direction,
        fields: {
            direction: { type: graphql_1.GraphQLString }
        }
    }))); /* why is the compiler so stupid */
}
var OutputFactoryOptions = {
    testOption: testOutputType
};
function testInputType(direction, objectTypeFactory) {
    return types_1.typeWrapper(objectTypeFactory({
        name: "TestInput" + direction,
        fields: {
            list: { type: new graphql_1.GraphQLList(graphql_1.GraphQLString) },
            sync: { type: graphql_1.GraphQLBoolean }
        }
    }));
}
var InputFactoryOptions = {
    testOption: testInputType
};
function factory(direction, objectTypeFactory, factoryOption, mixIn) {
    if (mixIn === void 0) { mixIn = {}; }
    return __assign({}, mixIn, { metadata: {
            type: objectTypeFactory({
                name: "metadata" + direction,
                fields: {
                    deleted: { type: graphql_1.GraphQLBoolean },
                    createdAt: { type: graphql_1.GraphQLFloat },
                    updatedAt: { type: graphql_1.GraphQLFloat }
                }
            })
        }, id: { type: graphql_1.GraphQLString }, customTitle: { type: graphql_1.GraphQLString } });
}
exports.HereLocationOutputFieldConfigMap = toOutput(factory('Output', function (o) { return new graphql_1.GraphQLObjectType(o); }, OutputFactoryOptions, IDFIELD));
exports.HereLocationOutputType = new graphql_1.GraphQLObjectType({
    description: 'Here Location Type Output',
    name: 'HereLocationOutput',
    fields: exports.HereLocationOutputFieldConfigMap
});
function toInput(f) {
    return f;
}
exports.HereLocationInputFieldConfigMap = toInput(factory('Input', function (o) { return new graphql_1.GraphQLInputObjectType(o); }, InputFactoryOptions, IDFIELD));
exports.HereLocationInputType = new graphql_1.GraphQLInputObjectType({
    description: 'Here Location Type Input',
    name: 'HereLocationInput',
    fields: exports.HereLocationInputFieldConfigMap
});
function hereUpdateLocation(resolve) {
    return {
        resolve: resolve,
        type: exports.HereLocationOutputType,
        args: {
            input: {
                type: new graphql_1.GraphQLInputObjectType({
                    name: 'UpdateHereLocationInput',
                    fields: wrapOptionals({
                        location: { type: exports.HereLocationInputType }
                    })
                })
            }
        },
        description: 'Retrieve here Locations'
    };
}
exports.hereUpdateLocation = hereUpdateLocation;
function hereGetLocation(resolve) {
    return {
        resolve: resolve,
        type: exports.HereLocationOutputType,
        args: {
            input: {
                type: new graphql_1.GraphQLInputObjectType({
                    name: 'GetHereLocationInput',
                    fields: wrapOptionals(__assign({}, IDFIELD))
                })
            }
        },
        description: 'Retrieve a Location'
    };
}
exports.hereGetLocation = hereGetLocation;
//# sourceMappingURL=generate-graphql-output.helper-test.js.map