"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var indent_1 = require("../indent");
var quote_js_string_1 = require("../quote-js-string");
// import { generateOutputFromSchema } from './graphql-output-from-type';
// import { createSchema } from './create-schema';
// import { QueryCollector } from './query-collector';
function fieldInvocation(d) {
    return d.queryField || d.mutationField;
}
function schema(style, fields) {
    if (!fields.length) {
        return [];
    }
    var ret = [];
    ret.push(indent_1.indent(0, style + ": {"));
    fields.forEach(function (field) {
        if (style == 'queries') {
            ret.push(indent_1.indent(2, field + ": " + field + "(function() {}),"));
        }
        else {
            ret.push(indent_1.indent(2, field + ": " + field + "(function() {}),"));
        }
    });
    ret.push(indent_1.indent(0, '},'));
    return ret;
}
function generateGraphqlOutput(items, fname) {
    if (fname === void 0) { fname = 'generatedGraphql'; }
    var out = [];
    out.push("(function " + fname + "() {");
    out.push(indent_1.indent(2, "var createSchema = require(" + quote_js_string_1.quoteJsString(path.join(__dirname, './create-schema')) + ").createSchema;"));
    out.push(indent_1.indent(2, "var QueryCollector = require(" + quote_js_string_1.quoteJsString(path.join(__dirname, '../query-collector')) + ").QueryCollector;"));
    out.push(indent_1.indent(2, "var graphqlOutputFromType = require(" + quote_js_string_1.quoteJsString(path.join(__dirname, './graphql-output-from-type')) + ").graphqlOutputFromType;"));
    out = out.concat(indent_1.indents(2, items.map(function (item) {
        return "var " + fieldInvocation(item).varName + " = require(" + quote_js_string_1.quoteJsString(fieldInvocation(item).path) + ")." + fieldInvocation(item).varName + ";";
    })));
    out = out.concat(indent_1.indents(2, items.map(function (item) {
        return "var " + item.query.varName + " = require(" + quote_js_string_1.quoteJsString(item.query.path) + ")." + item.query.varName + ";";
    })));
    out.push(indent_1.indent(2, 'var queryCollector = new QueryCollector();'));
    out.push(indent_1.indent(2, 'var schema = createSchema({'));
    out = out.concat(indent_1.indents(4, schema('queries', items
        .filter(function (item) { return item.queryField; })
        .map(function (item) { return item.queryField.varName; }))));
    out = out.concat(indent_1.indents(4, schema('mutations', items
        .filter(function (item) { return item.mutationField; })
        .map(function (item) { return item.mutationField.varName; }))));
    out.push(indent_1.indent(2, '});'));
    // out = out.concat(
    items.forEach(function (item) {
        out.push(indent_1.indent(2, '{'));
        out = out.concat(indent_1.indents(3, [
            "var " + item.output.varName + " = require(" + quote_js_string_1.quoteJsString(item.output.path) + ")." + item.output.varName + ";",
            // `${item.queryMethod}.inject(queryCollector.collect(${JSON.stringify(JSON.stringify(item))}), {}, generateOutputFromSchema(schema, ${item.outputType}));`,
            "queryCollector.collect(JSON.parse(" + JSON.stringify(JSON.stringify(item)) + "), graphqlOutputFromType(schema, " + item.output.varName + "));"
        ]));
        out.push(indent_1.indent(2, '}'));
    });
    // out.push('console.log(queryCollector);');
    out.push(indent_1.indent(2, 'return queryCollector;'));
    out.push('})');
    return out.join('\n');
}
exports.generateGraphqlOutput = generateGraphqlOutput;
//# sourceMappingURL=generate-graphql-output.js.map